/*
    blfile (Blacky List File)

    Dies Programm gibt den "neuen" Inhalt einer Datei aus.

    Beim ersten Start gibt das Programm die komplette Datei aus, und
    merkt sich in <Dateiname>.anh.fsize die Gre. Beim nchsten Start
    gibt das Programm alles aus was dazugekommen ist, merkt sich
    wieder die Gre, usw...

    Copyright (c) Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/


*/


#include <stdio.h>
#include "hofmeier.h"


char blacky_ver_info[] = "Blacky List File v0.05 (c) Copyright 1998-2000 Andreas Hofmeier";


main(argc, argv)
  int argc;
  char *argv[];
{
  int BUFSIZE = 1000;
  FILE *f;
  char s[200], buf[BUFSIZE];
  long start, size, i;

  if ((argc > 1) ? ((argv[1][0] == '-') && (toupper(argv[1][1]) == 'V')) : 0) {
    printf("%s\n\n", blacky_ver_info);
    printkinfo(stdout);
    exit(0);
  }

  /*Fehler bei den Parametern*/ 
  if ((argc < 2) || (argc > 3)) {
    printf("blfile <datei> [sizefile]\n");
    printf("or\nblfile -v: Zeige Versions/Lizenseinfo\n");
    exit(0);
  }

  // Letzte Gre Laden
  start = 0;
  // Externe Sizefile
  if (argc == 3) {
    strcpy(s, argv[2]);
  } else {
    // Normal, Sizefile: <FILENAME>.anh.fsize
    sprintf(s, "%s.anh.fsize", argv[1]);
  }
  // Open SizeFile
  if ((f = fopen(s, "r")) != NULL) {
    fscanf(f, "%d", &start);
    fclose(f);
  }
  // Wenn Datei nicht vorhanden, start=0!, Alles ausgeben
  // Gre der Quelldatei
  //  size = 0;
  // Quelldatei nicht vorhanden
  if ((size = filelen(argv[1])) < 1) {
    perror(argv[1]);
    exit(1);
  }
  // Wenn Quelldatei kleiner als Gespeicherter Wert, von Vorne...
  if (start > size) {
    fprintf(stderr, "** Warnung: Die Datei ist kleiner geworden! Beginne von vorne... (%s)\n", argv[1]);
    start = 0;
  }
  // Wenn Datei nicht Grergeworden ist, Exit
  if (size == start) {
    fprintf(stderr, "** Warnung: Die Datei ist nicht grer geworden! EXIT... (%s)\n", argv[1]);
    exit(0);
  }
  // Quelldatei ffnen
  if ((f = fopen(argv[1], "r")) == NULL) {
    perror(argv[1]);
    exit(1);
  }
  // Gehe zur Ausgangsposition...
  rewind(f);
  fseek(f, start, 1);
  // Gieb den Rest der Datei aus...
  for (i = start; i < size; i += BUFSIZE) {
    fread(buf, ((size - i) >= BUFSIZE) ? BUFSIZE : (size - i), 1, f);
    fwrite(buf, ((size - i) >= BUFSIZE) ? BUFSIZE : (size - i), 1, stdout);
  }
  // Speichere neue Possition...
  if ((f = fopen(s, "w")) == NULL) {
    perror(s);
    exit(1);
  }
  fprintf(f, "%d", size);
  ffsync(f);
  fclose(f);
  ffsync(stdout);
  // Exit...
  exit(0);
}
